//+------------------------------------------------------------------+
//|                                                    camarilla.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
//---- input parameters
extern int       GMTshift=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- TODO: add your code here
double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double today_open=0;
double ch1=0;
double ch2=0;
double ch3=0;
double ch4=0;
double cl1=0;
double cl2=0;
double cl3=0;
double cl4=0;
double D1=0.091667;
double D2=0.183333;
double D3=0.2750;
double D4=0.55;
double P=0,Q=0,S=0,R=0,M2=0,M3=0,S1=0,R1=0,M1=0,M4=0,S2=0,R2=0,M0=0,M5=0,S3=0,R3=0,L3=0,L4=0,H3=0,H4=0,nQ=0,nD=0,D=0;

//double D1=0.083333;
//double D2=0.166666;
//double D3=0.25;
//double D4=0.5;

int cnt=720;
double cur_day=0;
double prev_day=0;

double rates_d1[2][6];

//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices & calculate pivots

while (cnt!= 0)
{
	cur_day = TimeDay(Time[cnt]- (GMTshift*3600));
	
	if (prev_day != cur_day)
	{
		yesterday_close = Close[cnt+1];
		today_open = Open[cnt];
		yesterday_high = day_high;
		yesterday_low = day_low;

		day_high = High[cnt];
		day_low  = Low[cnt];

		prev_day = cur_day;
	}
   
   if (High[cnt]>day_high)
   {
      day_high = High[cnt];
   }
   if (Low[cnt]<day_low)
   {
      day_low = Low[cnt];
   }
	
//	SetIndexValue(cnt, 0);
	cnt--;

}

//------ Pivot Points ------

P = (yesterday_high + yesterday_low + yesterday_close)/3;//Pivot
R1 = (2*P)-yesterday_low;
S1 = (2*P)-yesterday_high;
R2 = P-S1+R1;
S2 = P-R1+S1;
R3 = (2*P)+(yesterday_high-(2*yesterday_low));
S3 = (2*P)-((2* yesterday_high)-yesterday_low);
M0 = (S2+S3)/2;
M1 = (S1+S2)/2;
M2 = (P+S1)/2;
M3 = (P+R1)/2;
M4 = (R1+R2)/2;
M5 = (R2+R3)/2;
//---- To display all 8 Camarilla pivots remove comment symbols below and
// add the appropriate object functions below

ch4 = ((yesterday_high - yesterday_low)* D4) + yesterday_close;
ch3 = ((yesterday_high - yesterday_low)* D3) + yesterday_close;
//ch2 = ((yesterday_high - yesterday_low) * D2) + yesterday_close;
//ch1 = ((yesterday_high - yesterday_low) * D1) + yesterday_close;

//cl1 = yesterday_close - ((yesterday_high - yesterday_low)*(D1));
//cl2 = yesterday_close - ((yesterday_high - yesterday_low)*(D2));
cl3 = yesterday_close - ((yesterday_high - yesterday_low)*(D3));
cl4 = yesterday_close - ((yesterday_high - yesterday_low)*(D4));

//---- Set line labels on chart window

if(ObjectFind("P label") != 0)
{
ObjectCreate("P label", OBJ_TEXT, 0, Time[20], P);
ObjectSetText("P label", " Pivot", 8, "Arial", White);
}
else
{
ObjectMove("P label", 0, Time[20], P);
}

if(ObjectFind("CH3") != 0)
{
ObjectCreate("CH3", OBJ_TEXT, 0, Time[35], ch3);
ObjectSetText("CH3", "Camarilla H3 ", 8, "Arial", White);
}
else
{
ObjectMove("CH3", 0, Time[35], ch3);
}

if(ObjectFind("CH4") != 0)
{
ObjectCreate("CH4", OBJ_TEXT, 0, Time[35], ch4);
ObjectSetText("CH4", "Camarilla H4 ", 8, "Arial", White);
}
else
{
ObjectMove("CH4", 0, Time[35], ch4);
}

if(ObjectFind("CL3") != 0)
{
ObjectCreate("CL3", OBJ_TEXT, 0, Time[35], cl3);
ObjectSetText("CL3", "Camarilla L3 ", 8, "Arial", White);
}
else
{
ObjectMove("CL3", 0, Time[35 ], cl3);
}

if(ObjectFind("CL4") != 0)
{
ObjectCreate("CL4", OBJ_TEXT, 0, Time[ 35], cl4);
ObjectSetText("CL4", "Camarilla L4 ", 8, "Arial", White);
}
else
{
ObjectMove("CL4", 0, Time[35], cl4);
}



//---- Set lines on chart window
//----- PIVOT --------

if(ObjectFind("R1 line") != 0)
{
ObjectCreate("R1 line", OBJ_HLINE, 0, Time[40], R1);
ObjectSet("R1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("R1 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("R1 line", 0, Time[40], R1);
}

if(ObjectFind("S1 line") != 0)
{
ObjectCreate("S1 line", OBJ_HLINE, 0, Time[40], S1);
ObjectSet("S1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("S1 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("S1 line", 0, Time[40], S1);
}

if(ObjectFind("R2 line") != 0)
{
ObjectCreate("R2 line", OBJ_HLINE, 0, Time[40], R2);
ObjectSet("R2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("R2 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("R2 line", 0, Time[40], R2);
}

if(ObjectFind("S2 line") != 0)
{
ObjectCreate("S2 line", OBJ_HLINE, 0, Time[40], S2);
ObjectSet("S2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("S2 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("S2 line", 0, Time[40], S2);
}

if(ObjectFind("R3 line") != 0)
{
ObjectCreate("R3 line", OBJ_HLINE, 0, Time[40], R3);
ObjectSet("R3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("R3 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("R3 line", 0, Time[40], R3);
}

if(ObjectFind("S3 line") != 0)
{
ObjectCreate("S3 line", OBJ_HLINE, 0, Time[40], S3);
ObjectSet("S3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("S3 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("S3 line", 0, Time[40], S3);
}

if(ObjectFind("M0 line") != 0)
{
ObjectCreate("M0 line", OBJ_HLINE, 0, Time[40], M0);
ObjectSet("M0 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M0 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M0 line", 0, Time[40], M0);
}

if(ObjectFind("M1 line") != 0)
{
ObjectCreate("M1 line", OBJ_HLINE, 0, Time[40], M1);
ObjectSet("M1 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M1 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M1 line", 0, Time[40], M1);
}

if(ObjectFind("M2 line") != 0)
{
ObjectCreate("M2 line", OBJ_HLINE, 0, Time[40], M2);
ObjectSet("M2 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M2 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M2 line", 0, Time[40], M2);
}

if(ObjectFind("M3 line") != 0)
{
ObjectCreate("M3 line", OBJ_HLINE, 0, Time[40], M3);
ObjectSet("M3 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M3 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M3 line", 0, Time[40], M3);
}

if(ObjectFind("M4 line") != 0)
{
ObjectCreate("M4 line", OBJ_HLINE, 0, Time[40], M4);
ObjectSet("M4 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M4 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M4 line", 0, Time[40], M4);
}

if(ObjectFind("M5 line") != 0)
{
ObjectCreate("M5 line", OBJ_HLINE, 0, Time[40], M5);
ObjectSet("M5 line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("M5 line", OBJPROP_COLOR, Yellow);
}
else
{
ObjectMove("M5 line", 0, Time[40], M5);
}


// --- THE CAMARILLA ---

if(ObjectFind("P line") != 0)
{
ObjectCreate("P line", OBJ_HLINE, 0, Time[40], P);
ObjectSet("P line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("P line", OBJPROP_COLOR, Magenta);
}
else
{
ObjectMove("P line", 0, Time[40], P);
}

if(ObjectFind("CH3line") != 0)
{
ObjectCreate("CH3line", OBJ_HLINE, 0, Time[40], ch3);
ObjectSet("CH3line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("CH3line", OBJPROP_COLOR, Red);
}
else
{
ObjectMove("CH3line", 0, Time[40], ch3);
}

if(ObjectFind("CH4line") != 0)
{
ObjectCreate("CH4line", OBJ_HLINE, 0, Time[40], ch4);
ObjectSet("CH4line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("CH4line", OBJPROP_COLOR, Green);
}
else
{
ObjectMove("CH4line", 0, Time[40], ch4);
}

if(ObjectFind("CL3line") != 0)
{
ObjectCreate("CL3line", OBJ_HLINE, 0, Time[40], cl3);
ObjectSet("CL3line", OBJPROP_STYLE, STYLE_DOT);
ObjectSet("CL3line", OBJPROP_COLOR, Green);
}
else
{
ObjectMove("CL3line", 0, Time[40], cl3);
}

if(ObjectFind("CL4line") != 0)
{
ObjectCreate("CL4line", OBJ_HLINE, 0, Time[40], cl4);
ObjectSet("CL4line", OBJPROP_STYLE, STYLE_SOLID);
ObjectSet("CL4line", OBJPROP_COLOR, Red);
}
else
{
ObjectMove("CL4line", 0, Time[40], cl4);
}


//---- done
   
//----
   return(0);
  }
//+------------------------------------------------------------------+